# -*- coding: utf-8 -*-

import numpy as np
import Factory
from Factory import Factory


class Case(object):
    """
    Classe Case, qui contient une position, une population et un inventaire d'équipement lootable
    """

    "INIT"
    def __init__(self, position):
        self._pos = position #tuple (x,y)
        self._population = []  # liste d'objet Personne
        self._loot = []  #liste d'objet Objet
    
    "STR"
    def __str__(self):
        return "### Case {0} ### \n Population : {1} \n Loot : {2}".format(self._pos, self._population, self._loot) 
    
    "GETTER"
    @property
    def pos(self):
        return self._pos
    @property
    def population(self):
        return(self._population)
    @property
    def loot(self):
        return(self._loot)
    
    "SETTER"
    @loot.setter
    def loot(self, modif):
        self._loot = modif
    
    def Modif_pop(self,modif_array):  #modif_array=array([[instance Personne,0],[instance Personne, 1]...])
        """
        Permet d'ajouter ou supprimer un ensemble d'objets Personne de la variable d'instance population
        Auteur: Sophie TUTON        
        """
        for elt in modif_array[:]:    #0 signifie "supprimer", 1 signifie "ajouter"
            if int(elt[1])==0:
                try:
                    self._population.remove(elt[0])
                except ValueError: #On traite le cas où la personne n'est pas sur la case
                    pass
            else:
                self._population.append(elt[0])
                
    def Modif_loot(self,modif_array): #array([[instance objet,0],[instance objet, 1]...])
       """        
       Permet d'ajouter ou supprimer un ensemble d'objets Objet de la variable d'instance loot
       Auteur: Sophie TUTON
       """
       for elt in modif_array:       #0 signifie "supprimer", 1 signifie "ajouter"
            if int(elt[1])==0:
                try:
                   self._loot.remove(elt[0])
                except ValueError: #On traite le cas où l'objet n'est pas sur la case
                   pass
            else:
                self._loot.append(elt[0])
                elt[0].pos = self
    
    
    def Create_add_PERS(self, class_name):
        """
        Permet de créer un Personne d'une certaine catégorie, et de la placer dans la variable d'instance population
        Auteur : Nicolas VEYLON, Sophie TUTON        
        """
        #Cette méthode utilise la fonction Factory.Factory.
        #Factory permet de passer très facilement du nom de la classe à la classe elle même
        #Factory sert de switch-case
        self.Modif_pop(np.array([[Factory(class_name)(self),1]])) 
        

    def Create_add_OBJ(self, class_name):
        """
        Permet de créer un Objet d'une certaine catégorie, et de la placer dans la variable d'instance loot
        Auteur : Nicolas VEYLON, Sophie TUTON        
        """
        #Cette méthode utilise la fonction Factory.Factory.
        #Factory permet de passer très facilement du nom de la classe à la classe elle même
        #Factory sert de switch-case
        self.Modif_loot(np.array([[Factory(class_name)(self),1]]))
        
    