# -*- coding: utf-8 -*-
import random
from save import save

"""
Les fonctions suivantes permettent de générer les différents événements aléatoires de la simulation
"""

def maladie(inst_pers,fact=2):
    """
    Rend malade la Personne inst_pers:
    La variable d'instance sick devient True
    diminution des variables d'instance faim, moral,courage et force
    Auteur: Sophie TUTON et Nicolas VEYLON
    """
    print("{0} tombe malade".format(inst_pers.__class__.__name__))
    save("{0} tombe malade".format(inst_pers.__class__.__name__))
    inst_pers.sick = True
    inst_pers.faim = inst_pers.faim//fact
    inst_pers.moral = inst_pers.moral//fact
    inst_pers.courage = inst_pers.courage//fact
    inst_pers.force = inst_pers.force//fact                  

def soin(inst_pers,fact=2):
    """
    Soigne la Personne inst_pers:
    La variable d'instance sick devient False
    augmentation des variables d'instance faim, moral,courage et force
    Auteur: Sophie TUTON et Nicolas VEYLON
    """
    print("{0} se soigne".format(inst_pers.__class__.__name__))
    save("{0} se soigne".format(inst_pers.__class__.__name__))
    inst_pers.sick = False
    inst_pers.faim *= fact
    inst_pers.moral *= fact
    inst_pers.courage *= fact
    inst_pers.force *= fact  

def explosion(carte,rayon=1,position=None): #position est un tuple correspondant au centre de l'explosion
    """
    Cet évènement est une explosion, centrée sur position, de rayon rayon
    Elle "détruit" toute instance Personne ou Objet dans le rayon de déflagration
    La destruction est en fait une suppression des instances dans les variables d'instances population et loot de la classe Case
    Auteur: Sophie TUTON    
    """
    if position==None:
        position=(random.randint(0,carte.shape[0]-1),random.randint(0,carte.shape[1]-1))
    print("Explosion en"+str(position))
    save("Explosion en"+str(position))
    "On va détruire les cases autour de position, et celle à position"
    for i in range(position[0]-rayon,position[0]+rayon+1):
        if i>=0 and i<carte.shape[0]:
            for j in range(position[1]-rayon,position[1]+rayon+1):
                if j>=0 and j<carte.shape[1]:
                    case=carte[i,j]
                    "On tue les personnes se trouvant sur la case considérées"
                    while case.population != []:
                        for perso in case.population:
                            perso.degat()
                    case.loot=[]
                    
def livraison(carte,strType=None,quantite=None):
    """
    Il s'agit d'une "livraison" d'instance Objet sur la case la plus centrale de la carte: l'église
    On crée et placve dans la variable d'instance loot de la case une quantité quantite d'instance Objet de type strType
    Auteur: Sophie TUTON    
    """
    position = (len(carte)//2-1, len(carte[0])//2-1)
    if strType==None:
        strType=random.choice(['Nourriture','Nourriture','Nourriture', 'Arme_a_feu','Arme_de_melee', 'Medicament'])
    if quantite==None:
        quantite=random.randint(1,5-3*(strType == 'Arme_a_feu') -2*(strType == 'Arme_de_melee') )
    print("Livraison de " + str(quantite) + " " + strType + " en " + str(position))
    save("Livraison de " + str(quantite) + " " + strType + " en " + str(position))
    n=0
    while n !=quantite:
        carte[position].Create_add_OBJ(strType)
        n+=1
    
        
   
                    
                        