﻿# -*- coding: utf-8 -*-

"""
These are the end times.

There was no hope of survival.

This is how they died.
"""

import numpy as np
import random
import matplotlib.pyplot as plt
from Case import Case
from Personne import *
from Objet import *
from Fct_event import *
from Loop_list import Loop_list, Node
from save import save

tour = 0
tour_vu = 0



def Map_generator(n):
    """
    Cette fonction permet de créer la carte de jeu. Des objets aleatoires, des batiments avec de l'équipement prédéfinis, etc..
    Auteur: Nicolas Veylon et Sophie Tuton
    """
    carte = np.empty((n,n), dtype=Case) # carte de la ville : carte[i,j] = Case((i,j))
    visu = np.zeros((n,n))
    for i in range(len(carte)):
        for j in range(len(carte[0])):
            carte[i,j] = Case((i,j))
            
    for i in range(len(carte)):   #loot aléatoire
        for j in range(len(carte[0])):
            if random.random() < 0.05:
                carte[i,j].Create_add_OBJ("Nourriture")
            if random.random() < 0.04:
                carte[i,j].Create_add_OBJ("Arme_de_melee")
            if random.random() < 0.02:
                carte[i,j].Create_add_OBJ("Arme_a_feu")
                
            
    for i in range(4):            #Supermarché
        for j in range(3):
            try:
                visu[len(carte)//5 + i,len(carte[0])//5 + j] = 1
                for k in range(10):
                    carte[len(carte)//5 + i,len(carte[0])//5 + j].Create_add_OBJ("Nourriture")
            except:
                pass
                
    for i in range(3):            #Hôpital
        for j in range(3):
            try:
                visu[len(carte[0])//4 + i,3*len(carte)//4 + j] = 2
                for k in range(5):
                    carte[len(carte)//4 + i,3*len(carte[0])//4 + j].Create_add_OBJ("Medicament")
            except:
                pass
                
    for i in range(3):            #Armurerie
        for j in range(2):
            try:
                visu[3*len(carte[0])//4 + i,len(carte)//5 + j] = 3
                for k in range(4):
                    carte[3*len(carte)//4 + i,len(carte[0])//5 + j].Create_add_OBJ("Arme_a_feu")
            except:
                pass

    dist=2      #Lotissement
    Lotissement=[]
    while len(carte)//3 + dist < len(carte):
        Lotissement.append((3*len(carte)//4 - 2,len(carte)//3 + dist ))
        Lotissement.append((3*len(carte)//4 ,len(carte)//3 + dist))
        Lotissement.append((3*len(carte)//4 + 2,len(carte)//3 + dist))
        Lotissement.append((3*len(carte)//4 + 4,len(carte)//3 + dist))
        dist+=2
    for k in range(len(Lotissement)):
        Maison=Lotissement[k]
        try:
            visu[Maison] = 4
            for i in range(3):
                if random.random()<0.5:
                    carte[Maison].Create_add_OBJ("Nourriture")
            for i in range(2):
                if random.random()<0.3:
                    carte[Maison].Create_add_OBJ("Medicament")
            if random.random() <0.8:
                carte[Maison].Create_add_OBJ("Arme_de_melee")
            if random.random()<0.1:
                carte[Maison].Create_add_OBJ("Arme_a_feu")        
        except:
            pass
    return carte
    
    
def init_PERS(carte, nbr_z, nbr_v):
    """
    Fonction permettant de crée nbr_z Zombie dans l'hôpital, et nbr_v Vivants répartis aléatoirement sur la carte
    Elle est utilisée pour initialiser la simulation
    Auteur: Sophie TUTON
    """
    nZ=nbr_z
    nV=nbr_v
    while nV>0:
        for i in range(len(carte)):
            if nV ==0:
                break
            for j in range(len(carte[0])):
                if nV ==0:
                    break
                elif random.random() < 0.05:
                    carte[i,j].Create_add_PERS(random.choice(['Enfant','Medecin','Militaire','Religieux_ext','LambdaV']))
                    nV-=1
    while nZ>0:
        for i in range(3):
            if nZ ==0:
                break
            for j in range(3):
                if nZ==0:
                    break
                elif random.random() < 0.1:
                    carte[len(carte)//4 + i,3*len(carte[0])//4 + j].Create_add_PERS('Tank')
                else:
                    carte[len(carte)//4 + i,3*len(carte[0])//4 + j].Create_add_PERS('LambdaZ')
                nZ-=1
    
def intervention(carte, n_mili, n_nour):
    for i in range(n_mili):
        carte[len(carte)-1,round(0.3*len(carte))].Create_add_PERS('Militaire')
    for i in range(n_nour):
        carte[round(len(carte)/2),round(len(carte)/2)].Create_add_OBJ('Nourriture')
    

"""MAIN"""

fichier=open("sauvegarde.txt",'w')
fichier.write('  ')
fichier.close()




if __name__ == "__main__":
    """
    ################# PHASE DE SIMULATION ##################
    """
    print("\nThese are the end times.\n\nThere was no hope of survival.\n\nThis is how they died.\n\n")
    save("\nThese are the end times.\n\nThere was no hope of survival.\n\nThis is how they died.\n\n")
    
    nb_z=5
    nb_v=15    
    
    players = Loop_list()   # liste principale des joueurs
    carte = Map_generator(20)
    init_PERS(carte,nb_z,nb_v)
               
    evo_nbV = [Vivant.nbV]
    evo_nbZ = [Zombie.nbZ]
    nbJ_init = Vivant.nbV + Zombie.nbZ


    while spawn != []:                          # transfert des nouveaux joueurs dans la liste principale players
        players.insert(spawn.pop())
    current_node = players.first
    
    nb_tour = 5000
    for i in range(nb_tour):                             # boucle principale  
        while spawn != []:                          # transfert des nouveaux joueurs dans la liste principale players
            players.insert(spawn.pop())
        current_player = current_node.content       # affectation du joueur  
        if random.random() < 0.003:
            explosion(carte)
        if random.random() < 0.01:
            livraison(carte)
        if current_player.isdead:                   # élimination du joueur s'il est mort dans le tour d'un autre joueur
            players.remove(current_player)
        elif current_player.respawn != 0:           # s'il le temps de respawn n'est pas terminée il ne joue pas
            print("\n\ntour " + str(i) + " : " + current_player.__class__.__name__ + str(current_player._pos.pos))        
            save(("\n\ntour " + str(i) + " : " + current_player.__class__.__name__ + str(current_player._pos.pos)))
            current_player.respawn -= 1
            print("{0} est en respawn".format(current_player.__class__.__name__))
            save("{0} est en respawn".format(current_player.__class__.__name__))
        else:                                       # déroulement du tour
            print("\n\ntour " + str(i) + " : " + current_player.__class__.__name__ + str(current_player._pos.pos))
            save("\n\ntour " + str(i) + " : " + current_player.__class__.__name__ + str(current_player._pos.pos))
            current_player.tour(carte)
        if current_player.isdead:                   # élimination du joueur s'il est mort pendant son tour
            players.remove(current_player)
        evo_nbV.append(Vivant.nbV)
        evo_nbZ.append(Zombie.nbZ)
        if Vivant.nbV == 0:
            print("\n\n#########\n\nTous les habitants ont été exterminés.\nTemps de survie : {0} tours.\n\n#########".format(i+1))
            save("\n\n#########\n\nTous les habitants ont été exterminés.\nTemps de survie : {0} tours.\n\n#########".format(i+1))        
            break
        if i == 400: #Affichage de la carte des presences au cours de la simulation
            repartition = np.zeros((len(carte), len(carte[0])))
            node = players.first
            while node.next != players.first:
                repartition[node.content.pos.pos] += 1
                node = node.next
            plt.figure()
            plt.matshow(repartition)
            plt.colorbar()
            plt.title("Distribution des joueurs sur la carte")
            plt.show()
        current_node = current_node.next            # changement de joueur
    
    plt.figure()
    plt.title("Evolution de la population")
    plt.plot(evo_nbV, 'b', label = "Vivant")
    plt.ylabel("Population")
    plt.xlabel("Tour")
    plt.plot(evo_nbZ, 'g', label = "Zombie")
    plt.ylim = [0,50]
    plt.legend()
    plt.show()
