﻿# -*- coding: utf-8 -*-

"""
These are the end times.

There was no hope of survival.

This is how they died.
"""

from enstaZ import *
from search_in_save import search_in_save
from outil_liste import liste_sous, liste_add

from PyQt4 import QtCore, QtGui, uic
from guiqwt.plot import CurveWidget, PlotManager
from guiqwt.builder import make
from random import randint
import guiqwt

dict_pos_alea = {} #Dictionnaire dont les clés sont des joueurs (instances Personne) dont les valeurs correspondent à un couple de valeurs aléatoires servant à les positionner dans la case où ils se trouvent
dict_color={Militaire:QtGui.QColor(130,0,210,255),Medecin:QtGui.QColor(0,47,167,255), LambdaV:QtGui.QColor(0,127,255,255),Religieux_ext:QtGui.QColor(142,162,205,255),Enfant:QtGui.QColor(121,248,241,255),Tank:QtGui.QColor(58,242,75,255),LambdaZ:QtGui.QColor(58,242,75,255)} #dictionnaire liant la classe des Personnes à une couleur d'affichage

try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    def _fromUtf8(s):
        return s

try:
    _encoding = QtGui.QApplication.UnicodeUTF8
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig, _encoding)
except AttributeError:
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig)
        
class dialog(QtGui.QDialog):
    def __init__(self,*args):
        QtGui.QDialog.__init__(self, *args)
        self.ui = uic.loadUi('parametres.ui', self)
        
        

class uiZ(QtGui.QMainWindow):
    def __init__(self,*args):
        """
        Initialisation de l'instance uiZ correspondant à l'interface graphique
        Ici on prépare tous les widgets préalablement crée à partir de Qt Designer
        Auteur: Nicolas Veylon
        """
        QtGui.QMainWindow.__init__(self, *args)
        self.ui = uic.loadUi('interface.ui', self) 
        self.ui.widget.setAutoFillBackground(True) #autorise l'affichage d'un fond d'écran dans widget
        self.ui.widget_2.setAutoFillBackground(True)#autorise l'affichage d'un fond d'écran dans widget_2
        self.ui.widget.setFixedSize(1.2*self.height(),1.2*self.height())  
        self.ui.widget_2.setFixedSize(1.2*self.height(),1.2*self.height())
        
        
        
        self.ui.label_2.setText(_translate("MainWindow","\nThese are the end times.\n\nThere was no hope of survival.\n\nThis is how they died.\n\n",None))

        #Initialisation des courbes de l'onglet 3.
        self.itV=make.mcurve([0],evo_nbV,'-',label="Vivant")
        penV = QtGui.QPen()
        penV.setWidth(10)
        penV.setColor(QtCore.Qt.blue)
        self.itV.setPen(penV)
        
        self.itZ=make.mcurve([0],evo_nbZ,'-',label="Zombie")
        penZ = QtGui.QPen()
        penZ.setWidth(10)
        penZ.setColor(QtCore.Qt.green)
        self.itZ.setPen(penZ)
        
        self.itM=make.mcurve([0],liste_sous([nbJ_init]*len(evo_nbV),liste_add(evo_nbV, evo_nbZ)),'-',label="Morts")
        penM = QtGui.QPen()
        penM.setWidth(10)
        penM.setColor(QtCore.Qt.red)
        self.itM.setPen(penM)
         
        self.itLabExpl=make.mcurve([],[],'y*',label="Explosion")
        self.itLabLivr=make.mcurve([],[],'y+',label="Livraison")
    
        self.ui.curvewidget.plot.set_titles(title="Nombre de personnes en fonction du tour")
        
        self.ui.curvewidget.plot.add_item(self.itV)
        self.ui.curvewidget.plot.add_item(self.itZ)
        self.ui.curvewidget.plot.add_item(self.itM)
        self.ui.curvewidget.plot.add_item(self.itLabExpl)
        self.ui.curvewidget.plot.add_item(self.itLabLivr)
        self.ui.curvewidget.plot.add_item(make.legend('TR'))
        self.ui.curvewidget.plot.setAutoReplot(True)
        self.ui.pm = PlotManager(self.ui.curvewidget)        
        
        self.last_tour = np.inf   #permet de mémoriser le dernier tour de la simulation
                                  #et entre autre à savoir si la simulation est terminée
        w_map = self.widget.frameGeometry().width()
        h_map = self.widget.frameGeometry().height()
        pixmap = QtGui.QPixmap("map.png")
        pixmap = pixmap.scaled(w_map, h_map)
        palette= QtGui.QPalette()
        palette.setBrush(QtGui.QPalette.Background,QtGui.QBrush(pixmap))  #palette correspond donc à l'affichage de l'image map.png correspondant à la carte de la ville où est simuler l'apocalyspe Zombie
        self.ui.widget.setPalette(palette) #On affiche cette map en arière plan de widget  (où seront affichés les Personnes)
        self.ui.widget_2.setPalette(palette)#On affiche cette map en arière plan de widget_2 (où seront affichés les Objets )
        self.painter = QtGui.QPainter()
        self.penB=QtGui.QPen()
        self.penB.setColor(QtGui.QColor(0,0,255,255))
        self.penB.setWidth(2)
        
        #Définitions des paintEvent pour dessiner la légende, les points Personne dans widget et les points objets dans widget_2
        self.ui.widget.paintEvent = self.tracer
        self.ui.widget_2.paintEvent=self.tracer_obj
        self.ui.widget_4.paintEvent=self.legende
        
        #Définition des signaux et slots des boutons existants
        self.ui.pushButton_2.clicked.connect(self.moinsdixtour) #Appuyer ==> montrer les 10 tours de jeu précédent (méthode moinsdixtour)
        self.ui.pushButton_6.clicked.connect(self.moinsuntour) #Appuyer ==> montrer le tour de jeu précédent (méthode moinsuntour)
        self.ui.pushButton_3.clicked.connect(self.plusuntour) #Appuyer ==> montrer le tour de jeu suivant (méthode plusuntour)
        self.ui.pushButton_4.clicked.connect(self.plusdixtour) #Appuyer ==> montrer les 10 tours de jeu suivants (méthode plusdixtour)
        self.ui.pushButton_5.clicked.connect(self.simuler) #Appuyer ==> montrer tous le reste de la simulation (méthode simuler)
        self.ui.pushButton_7.clicked.connect(self.reset)#Appuyer ==> réinitialiser une simulation (méthode reset)
        self.ui.pushButton.clicked.connect(self.toBegin)#Appuyer ==> montrer le premier tour (méthode toBegin)      
        
        #Initialisation des lcd         
        self.ui.lcdNumber.display(tour_vu) #affichage du tour visualisé
        self.ui.lcdNumber_2.display(evo_nbV[tour_vu]) #Affichage du nombre de Vivants lors du tour visualisé
        self.ui.lcdNumber_3.display(evo_nbZ[tour_vu])  #Affichage du nombre de Zombies lors du tour visualisé
        self.ui.lcdNumber_4.display(nbJ_init - evo_nbV[tour_vu] - evo_nbZ[tour_vu])  #Affichage du nombre de Mort lors du tour visualisé
        
    
    
    """"""""""""""" Fonctions permettant de tracer les éléments graphiques de l'interface """""""""""""""    
    
    
    
    def tracer(self, *args):
        """
        Méthode permettant de tracer des points colorés représentant les joueurs dans widget.
        Auteur: Nicolas Veylon
        """
        global dict_pos_alea
        
        # définition des variables de tailles de la carte et de l'arrière plan
        size = len(carte)
        w_map = self.widget.frameGeometry().width()
        h_map = self.widget.frameGeometry().height()
        
        #Initialisation d'un peintre
        self.painter.begin(self.widget)
        self.painter.setRenderHint(QtGui.QPainter.HighQualityAntialiasing)
        
        #Calcul de la position du "premier joueur" dans la liste chainée cyclique players.
        keys = dict_pos_alea.keys()
        curr_node=players.first
        if curr_node.content not in keys: #si les composante aléatoire de la position ne sont pas déjà définit, on les définit
            a = randint(0,round(w_map/size))
            b = randint(0,round(h_map/size))
            dict_pos_alea[curr_node.content] = (a, b)
        x = curr_node.content.pos.pos[0]*w_map/size + dict_pos_alea[curr_node.content][0] #position = position sur la carte + composante aléatoire pour placé dans la case
        y = curr_node.content.pos.pos[1]*h_map/size + dict_pos_alea[curr_node.content][1]
        
        #Affichage à la bonne position du "premier joueur" dans la liste chainée cyclique players
        if type(curr_node.content) is Tank:
            self.painter.setPen(QtCore.Qt.NoPen) #pas de contour
            self.painter.setBrush(dict_color[type(curr_node.content)]) #les couleurs sont référencées dans le dictionnaire dict_color
            self.painter.drawEllipse(round(x),round(y),25,25)
        else:
            if type(curr_node.content) is LambdaZ:
                self.painter.setPen(QtCore.Qt.NoPen)
            else:
                self.painter.setPen(self.penB) #contour
            self.painter.setBrush(dict_color[type(curr_node.content)]) #couleur intérieure
            self.painter.drawEllipse(round(x),round(y),15,15)
        
        #On fait de même (Calcul de la position + Affichage) pour les autres joueurs
        curr_node=curr_node.next
        while curr_node != players.first:
            if curr_node.content not in keys:
                a = randint(0,round(w_map/size))
                b = randint(0,round(h_map/size))
                dict_pos_alea[curr_node.content] = (a, b)
            x = curr_node.content.pos.pos[0]*w_map/size + dict_pos_alea[curr_node.content][0]
            y = curr_node.content.pos.pos[1]*h_map/size + dict_pos_alea[curr_node.content][1]
            if type(curr_node.content) is Tank:
                self.painter.setPen(QtCore.Qt.NoPen)
                self.painter.setBrush(dict_color[type(curr_node.content)])
                self.painter.drawEllipse(round(x),round(y),25,25)                    
            else:
                if type(curr_node.content) is LambdaZ:
                    self.painter.setPen(QtCore.Qt.NoPen)
                else:
                    self.painter.setPen(self.penB)
                self.painter.setBrush(dict_color[type(curr_node.content)])
                self.painter.drawEllipse(round(x),round(y),15,15)
            curr_node=curr_node.next
        self.painter.end()
        
        
    def tracer_obj(self,*args):
        """
        Méthode permettant de tracer des points colorés représentant les objets dans widget_2
        Auteur: Sophie Tuton
        """
        global dict_pos_alea
        
        # définition des variables de tailles de la carte et de l'arrière plan
        size = len(carte)
        w_map = self.widget_2.frameGeometry().width()
        h_map = self.widget_2.frameGeometry().height()
        
        #Initialisation d'un peintre
        self.painter.begin(self.widget_2)
        self.painter.setRenderHint(QtGui.QPainter.HighQualityAntialiasing)
        self.painter.setPen(QtCore.Qt.NoPen)
        
        #Pour tous les instances cases, on inspecte le loot et on définit les positions avec deux composantes: celle correspondant à la case et une composante aléatoires correspondant à la position dans la case
        keys = dict_pos_alea.keys()
        for ligne in carte:
            for case in ligne:
                xcase = case.pos[0]*w_map/size 
                ycase = case.pos[1]*h_map/size
                for objet in case.loot:
                    if objet not in keys:
                        a=randint(0,round(w_map/size))
                        b=randint(0,round(h_map/size))
                        dict_pos_alea[objet]=(a,b)
                    x=xcase+dict_pos_alea[objet][0]
                    y=ycase+dict_pos_alea[objet][1]
                    
                    #On dessine à au bon endroit un rond coloté représentant l'objet.
                    if type(objet) is Nourriture:
                        self.painter.setBrush(QtGui.QColor(255,127,0,255))
                        self.painter.drawEllipse(round(x),round(y),10,10)
                    elif type(objet) is Medicament:
                        self.painter.setBrush(QtCore.Qt.green)
                        self.painter.drawEllipse(round(x),round(y),10,10)
                    elif type(objet) is Arme_a_feu:
                        self.painter.setBrush(QtCore.Qt.black)
                        self.painter.drawEllipse(round(x),round(y),10,10)
                    elif type(objet) is Arme_de_melee:
                        self.painter.setBrush(QtCore.Qt.white)
                        self.painter.drawEllipse(round(x),round(y),10,10)
                        
        self.painter.end()
        
    def legende(self,*args):
        """
        Méthode permettant d'afficher la légende de widget et widget_2
        Auteur: Sophie Tuton
        """
        self.painter.begin(self.widget_4)
        #Zombies
        self.painter.setPen(QtCore.Qt.NoPen)
        self.painter.setBrush(dict_color[LambdaZ])
        self.painter.drawEllipse(0, self.widget_4.frameGeometry().height()//14, 25, 25)
        self.painter.drawEllipse(0, 2*self.widget_4.frameGeometry().height()//14, 15, 15)
        
        #Objets
        self.painter.setBrush(QtGui.QColor(255,127,0,255))
        self.painter.drawEllipse(0, 10*self.widget_4.frameGeometry().height()//14, 10, 10)
        self.painter.setBrush(QtCore.Qt.green)
        self.painter.drawEllipse(0, 11*self.widget_4.frameGeometry().height()//14, 10, 10)
        self.painter.setBrush(QtCore.Qt.white)
        self.painter.drawEllipse(0, 12*self.widget_4.frameGeometry().height()//14, 10, 10)
        self.painter.setBrush(QtCore.Qt.black)
        self.painter.drawEllipse(0, 13*self.widget_4.frameGeometry().height()//14, 10, 10)
        
        #Humains
        self.painter.setPen(self.penB)
        self.painter.setBrush(dict_color[Militaire])
        self.painter.drawEllipse(0, 4*self.widget_4.frameGeometry().height()//14, 15, 15)
        self.painter.setBrush(dict_color[Medecin])
        self.painter.drawEllipse(0, 5*self.widget_4.frameGeometry().height()//14, 15, 15)
        self.painter.setBrush(dict_color[LambdaV])
        self.painter.drawEllipse(0, 6*self.widget_4.frameGeometry().height()//14, 15, 15)
        self.painter.setBrush(dict_color[Religieux_ext])
        self.painter.drawEllipse(0, 7*self.widget_4.frameGeometry().height()//14, 15, 15)
        self.painter.setBrush(dict_color[Enfant])
        self.painter.drawEllipse(0, 8*self.widget_4.frameGeometry().height()//14, 15, 15)
        self.painter.end()
              
        
        
        
    """""""""""""""  Fonctions propres à la simulation  """""""""""""""""""""""""""        
        
        
        
        
    def genere_tour(self,nbr=1,spawn=spawn):
        """
        Méthode appelée pour jouer nbr tours de jeux
        Auteur : Sophie Tuton et Nicolas Veylon
        """
        global carte,players,current_node,evo_nbV,evo_nbZ, tour, tour_vu, nbJ_init
        global T_Explo,M_Explo, T_Livr,V_Livr
        for i in range(tour+1, tour+ 1 + nbr):
            tour += 1             
            while spawn != []:                          # transfert des nouveaux joueurs dans la liste principale players
                players.insert(spawn.pop())
            current_player = current_node.content       # affectation du joueur  
            if random.random() < 0.003:
                explosion(carte)
                T_Explo.append(tour)
                M_Explo.append(nbJ_init-evo_nbV[tour-1]-evo_nbZ[tour-1])
                self.itLabExpl.set_data(T_Explo,M_Explo) #affihage de l'explosion sur le curvewiget au niveau de la courbe des morts
            if random.random() < 0.01:
                livraison(carte)
                T_Livr.append(tour-1)
                V_Livr.append(evo_nbV[tour-1])
                self.itLabLivr.set_data(T_Livr,V_Livr)  #affihage de la livraison sur le curvewiget au niveau de la courbe des Vivants
            while current_player.isdead:                   # élimination du joueur s'il est mort dans le tourd'un autre joueur
                players.remove(current_player)        
                current_node = current_node.next
                current_player = current_node.content       # affectation du joueur
            if current_player.respawn != 0:           # s'il le temps de respawn n'est pas terminée il ne joue pas
                print("\n\ntour " + str(i) + " : " + current_player.__class__.__name__ + str(current_player._pos.pos))        
                save(("\n\ntour " + str(i) + " : " + current_player.__class__.__name__ + str(current_player._pos.pos)))
                current_player.respawn -= 1
                print("{0} est en respawn".format(current_player.__class__.__name__))
                save("{0} est en respawn".format(current_player.__class__.__name__))
            else:                                       # déroulement du tour
                print("\n\ntour " + str(i) + " : " + current_player.__class__.__name__ + str(current_player._pos.pos))
                save("\n\ntour " + str(i) + " : " + current_player.__class__.__name__ + str(current_player._pos.pos))
                current_player.tour(carte)
            if current_player.isdead:                   # élimination du joueur s'il est mort pendant son tour
                players.remove(current_player)
            if settings.checkBox.isChecked() and tour == tour_interv: #Intervention des Militaires
                intervention(carte,nb_mili,15*nb_mili)
                nbJ_init += nb_mili
            if Vivant.nbV == 0:
                print("\n\n#########\n\nLa population a été exterminé.\nTemps de survie : {0} tours.\n\n#########".format(i))
                save("\n\n#########\n\nLa population a été exterminé.\nTemps de survie : {0} tours.\n\n#########".format(i))      
                QtGui.QMessageBox.question(self, 'Défaite...',"La population a été exterminé.\n\nTemps de survie : {0} tours.".format(i), QtGui.QMessageBox.Ok)
                self.last_tour = tour      
                QtGui.QApplication.processEvents()
                self.ui.widget.update()
                self.ui.widget_2.update()
                
                #Affichage des courbes du nombre de vivants, de zombies, et de morts en fonction du tour, sur le urvewidget
         
                evo_nbV.append(Vivant.nbV)
                evo_nbZ.append(Zombie.nbZ)                
                evo_nbJ.append(nbJ_init)                
                self.itV.set_data(np.arange(tour+1),evo_nbV)
                self.itZ.set_data(np.arange(tour+1),evo_nbZ)
                self.itM.set_data(np.arange(tour+1),liste_sous(evo_nbJ,liste_add( evo_nbV, evo_nbZ)))
                
                self.curvewidget.plot.set_axis_limits('bottom',-1,tour+1)
                self.curvewidget.plot.set_axis_limits('left',0,0.5+max(evo_nbJ+liste_add( evo_nbV, evo_nbZ)+evo_nbV+evo_nbV))
                break
            elif Zombie.nbZ == 0:
                print("\n\n#########\n\nLes habitants ont survecu à l'apocalypse.\nTemps pour éradiquer la menace : {0} tours.\n\n#########".format(i))
                save("\n\n#########\n\nLes habitants ont survecu à l'apocalypse.\nTemps pour éradiquer la menace : {0} tours.\n\n#########".format(i))      
                QtGui.QMessageBox.question(self, "Victoire !!!","Les habitants ont survecu à l'apocalypse.\n\nTemps pour éradiquer la menace : {0} tours.".format(i), QtGui.QMessageBox.Ok)          
                self.last_tour = tour                
                QtGui.QApplication.processEvents()
                self.ui.widget.update()
                self.ui.widget_2.update()
                #Affichage des courbes du nombre de vivants, de zombies, et de morts en fonction du tour, sur le urvewidget
                
                evo_nbV.append(Vivant.nbV)
                evo_nbZ.append(Zombie.nbZ)                
                evo_nbJ.append(nbJ_init)                
                self.itV.set_data(np.arange(tour+1),evo_nbV)
                self.itZ.set_data(np.arange(tour+1),evo_nbZ)
                self.itM.set_data(np.arange(tour+1),liste_sous(evo_nbJ,liste_add( evo_nbV, evo_nbZ)))
                
                self.curvewidget.plot.set_axis_limits('bottom',-1,tour+1)
                self.curvewidget.plot.set_axis_limits('left',0,0.5+max(evo_nbJ+liste_add( evo_nbV, evo_nbZ)+evo_nbV+evo_nbV))
                break
            current_node = current_node.next            # changement de joueurs
            QtGui.QApplication.processEvents()          # permet de garder la main sur l'interface malgré la simulation
            self.ui.widget.update()                     #mise à jour des maps
            self.ui.widget_2.update()
            
            #Affichage des courbes du nombre de vivants, de zombies, et de morts en fonction du tour, sur le urvewidget
            
            evo_nbV.append(Vivant.nbV)
            evo_nbZ.append(Zombie.nbZ)
            evo_nbJ.append(nbJ_init)            
            self.itV.set_data(np.arange(tour+1),evo_nbV)
            self.itZ.set_data(np.arange(tour+1),evo_nbZ)
            self.itM.set_data(np.arange(tour+1),liste_sous(evo_nbJ,liste_add( evo_nbV, evo_nbZ)))
            
            self.curvewidget.plot.set_axis_limits('bottom',-1,tour+1)
            self.curvewidget.plot.set_axis_limits('left',0,0.5+max(evo_nbJ+liste_add( evo_nbV, evo_nbZ)+evo_nbV+evo_nbV))

        
    def moinsuntour(self):
        """
        Méthode appelée lors de l'appuie sur un certain bouton pushButton_6.
        Elle correspond à l'affichage du tour précédant celui qui est affiché actuellemnt
        Auteur : Sophie Tuton
        """
        global tour, tour_vu
        if tour_vu >1:
            tour_vu-=1
            self.ui.label_2.setText(_translate("MainWindow", search_in_save(tour_vu), None))
        self.ui.lcdNumber.display(tour_vu)
        self.ui.lcdNumber_2.display(evo_nbV[tour_vu])
        self.ui.lcdNumber_3.display(evo_nbZ[tour_vu])
        self.ui.lcdNumber_4.display(nbJ_init - evo_nbV[tour_vu] - evo_nbZ[tour_vu])
            
    def moinsdixtour(self):
        """
        Méthode appelée lors de l'appuie sur un certain bouton pushButton_2.
        Elle correspond à l'affichage des 10 tours précédant celui qui est affiché actuellemnt
        Auteur : Sophie Tuton
        """
        global tour, tour_vu
        if tour_vu-10>0:
            tour_vu-=10
            self.ui.label_2.setText(_translate("MainWindow", search_in_save(tour_vu-9,tour_vu), None))
        else:
            self.ui.label_2.setText(_translate("MainWindow", search_in_save(0,tour_vu), None))
            tour_vu = 0
        self.ui.lcdNumber.display(tour_vu)
        self.ui.lcdNumber_2.display(evo_nbV[tour_vu])
        self.ui.lcdNumber_3.display(evo_nbZ[tour_vu])
        self.ui.lcdNumber_4.display(nbJ_init - evo_nbV[tour_vu] - evo_nbZ[tour_vu])

        
    
    
            
    def plusuntour(self):
        """
        Méthode permettant de visualiser le prochain tour
        Auteur : Sophie Tuton
        """
        global current_node, tour, tour_vu
        if tour_vu < self.last_tour:
            if tour==tour_vu:
                if tour==0:
                    print("\nThese are the end times.\n\nThere was no hope of survival.\n\nThis is how they died.\n\n")
                    save("\nThese are the end times.\n\nThere was no hope of survival.\n\nThis is how they died.\n\n")                            # boucle principale  
                self.genere_tour()
                self.ui.label_2.setText(_translate("MainWindow", search_in_save(tour), None))
                
            else: 
                self.ui.label_2.setText(_translate("MainWindow", search_in_save(tour_vu+1), None))
            tour_vu+=1
            self.ui.lcdNumber.display(tour_vu)
            self.ui.lcdNumber_2.display(evo_nbV[tour_vu])
            self.ui.lcdNumber_3.display(evo_nbZ[tour_vu])
            self.ui.lcdNumber_4.display(nbJ_init - evo_nbV[tour_vu] - evo_nbZ[tour_vu])
    
            
    def plusdixtour(self):
        """
        Méthode permettant de visualiser les dix prochains tours
        Auteur : Sophie Tuton et Nicolas Veylon
        """
        global current_node, tour, tour_vu
        if tour_vu < self.last_tour-10:
            if tour_vu == tour:
                if tour==0:
                        print("\nThese are the end times.\n\nThere was no hope of survival.\n\nThis is how they died.\n\n")
                        save("\nThese are the end times.\n\nThere was no hope of survival.\n\nThis is how they died.\n\n")                            # boucle principale  
                self.genere_tour(10)
                self.ui.label_2.setText(_translate("MainWindow", search_in_save(tour-9,tour), None))
                
            elif tour_vu + 10 <= tour:
                self.ui.label_2.setText(_translate("MainWindow", search_in_save(tour_vu+1,tour_vu+10), None))        
            else: #i.e. tour< tour_vu +10
                self.genere_tour(10 - (tour-tour_vu) )
                self.ui.label_2.setText(_translate("MainWindow", search_in_save(tour_vu-9,tour_vu), None))
            tour_vu+=10
            self.ui.lcdNumber.display(tour_vu)
            """ pb avec les lignes suivantes"""
            try:
                self.ui.lcdNumber_2.display(evo_nbV[tour_vu])
            except:
                self.ui.lcdNumber_2.display(0)
            try:
                self.ui.lcdNumber_3.display(evo_nbZ[tour_vu])
            except:
                self.ui.lcdNumber_3.display(0)
            try:
                self.ui.lcdNumber_4.display(nbJ_init - evo_nbV[tour_vu] - evo_nbZ[tour_vu])
            except:
                self.ui.lcdNumber_4.display(nbJ_init - evo_nbZ[tour_vu])
        else:
            tour_vu = self.last_tour
            self.ui.label_2.setText(_translate("MainWindow", search_in_save(tour_vu-9,tour_vu), None))
            self.ui.lcdNumber.display(tour_vu)
            self.ui.lcdNumber_2.display(evo_nbV[tour_vu])
            self.ui.lcdNumber_3.display(evo_nbZ[tour_vu])
            self.ui.lcdNumber_4.display(nbJ_init - evo_nbV[tour_vu] - evo_nbZ[tour_vu])
        
        
    def simuler(self):
        """
        Méthode permettant d'effectuer la simulation jusqu'à la fin
        Auteur : Nicolas Veylon
        """
        global current_node, tour, tour_vu
        while Vivant.nbV != 0 and Zombie.nbZ != 0:
            self.plusuntour()
            QtGui.QApplication.processEvents()
        tour_vu=tour
        self.ui.label_2.setText(_translate("MainWindow", search_in_save(tour), None))
        self.ui.lcdNumber.display(tour_vu)
        
    def reset(self):
        """
        Méthode appelée pour recommencer une partie
        Auteur : Nicolas Veylon
        """
        global dict_pos_alea, tour, tour_vu, current_node
        global carte, fichier, players, evo_nbV, evo_nbZ, evo_nbJ, nbJ_init, spawn,T_Explo,M_Explo,T_Livr,V_Livr
        fichier=open("sauvegarde.txt",'w')
        fichier.write('  ')
        fichier.close()
        carte = Map_generator(20)
        Vivant.nbV = 0
        Zombie.nbZ = 0
        players = Loop_list()
        init_PERS(carte,nb_z, nb_v)
        evo_nbV = [Vivant.nbV]
        evo_nbZ = [Zombie.nbZ]
        nbJ_init = Vivant.nbV + Zombie.nbZ
        evo_nbJ = [nbJ_init]
        T_Explo,M_Explo=[],[]
        T_Livr,V_Livr=[],[]
        while spawn != []:                          # transfert des nouveaux joueurs dans la liste principale players
            players.insert(spawn.pop())
        current_node = players.first
        tour = 0
        tour_vu = 0
        self.last_tour = np.inf
        dict_pos_alea = {}
        self.ui.lcdNumber.display(tour_vu)
        self.ui.lcdNumber_2.display(evo_nbV[tour_vu])
        self.ui.lcdNumber_3.display(evo_nbZ[tour_vu])
        self.ui.lcdNumber_4.display(nbJ_init - evo_nbV[tour_vu] - evo_nbZ[tour_vu])
        self.ui.widget.update()
        self.ui.widget_2.update()
        self.ui.label_2.setText(_translate("MainWindow","\nThese are the end times.\n\nThere was no hope of survival.\n\nThis is how they died.\n\n",None))
        self.itV.set_data([0],evo_nbV)
        self.itZ.set_data([0],evo_nbZ)
        self.itM.set_data([0],liste_sous(evo_nbJ,liste_add(evo_nbV, evo_nbZ)))
        self.itLabExpl.set_data([],[])
        self.itLabLivr.set_data([],[])
        
    def toBegin(self):
        """
        Méthode appelée lors de l'appuie sur un certain bouton pushButton.
        Elle correspond à l'affichage du premier tour.
        Auteur : Nicolas Veylon
        """
        global tour, tour_vu
        self.ui.label_2.setText(_translate("MainWindow", search_in_save(0), None))
        tour_vu = 0
        self.ui.lcdNumber.display(tour_vu)
        self.ui.lcdNumber_2.display(evo_nbV[tour_vu])
        self.ui.lcdNumber_3.display(evo_nbZ[tour_vu])
        self.ui.lcdNumber_4.display(nbJ_init - evo_nbV[tour_vu] - evo_nbZ[tour_vu])
        
        
        



        
        
def interface():
    """
    Fonction lancée après la boite de dialogue au démarrage du programme. Cette fonction lance l'interface avec les paramètres
    indiqués dans la boite de dialogue.
    Auteur : Nicolas Veylon
    """
    global nb_v, nb_z, nbJ_init, current_node,spawn, players,carte, interv_mili, nb_mili, tour_interv, evo_nbV, evo_nbZ, evo_nbJ
    nb_v = settings.ui.spinBox.value()
    nb_z = settings.ui.spinBox_2.value()
    nb_mili = settings.ui.spinBox_4.value()
    tour_interv = settings.ui.spinBox_3.value()
    
    init_PERS(carte,nb_z,nb_v)
    nbJ_init = Vivant.nbV + Zombie.nbZ
    evo_nbV = [Vivant.nbV]
    evo_nbZ = [Zombie.nbZ]
    evo_nbJ = [nbJ_init]
    while spawn != []:                          # transfert des nouveaux joueurs dans la liste principale players
        players.insert(spawn.pop())
    current_node = players.first
    interfaceZ = uiZ()
    interfaceZ.lcdNumber.display(tour_vu)
    interfaceZ.lcdNumber_2.display(nb_v)
    interfaceZ.lcdNumber_3.display(nb_z)
    interfaceZ.lcdNumber_4.display(nbJ_init - nb_v - nb_z)
    interfaceZ.ui.itV.set_data([0],evo_nbV)
    interfaceZ.ui.itZ.set_data([0],evo_nbZ)
    interfaceZ.ui.itM.set_data([0],liste_sous([nbJ_init]*len(evo_nbV),liste_add(evo_nbV, evo_nbZ)))
    interfaceZ.ui.itLabExpl.set_data([],[])
    interfaceZ.ui.itLabLivr.set_data([],[])
    
    interfaceZ.show()
    interfaceZ.setWindowState(QtCore.Qt.WindowMaximized)
    interfaceZ.setFixedSize(interfaceZ.size())
        
if __name__ == "__main__":
    import sys
    nb_z= 5  #nombre de zombies initial 
    nb_v= 15 #nombre de survivants initial
    players = Loop_list()   # liste principale des joueurs
    current_node = None
    interv_mili = None
    nb_mili = None
    tour_interv = None
    carte = Map_generator(20)
               
    evo_nbV = [0]
    evo_nbZ = [0]
    nbJ_init = 0
    evo_nbJ = [0]
    
    T_Explo,M_Explo=[],[]
    T_Livr,V_Livr=[],[]
    app = QtGui.QApplication(sys.argv)
    settings = dialog()
    settings.show()
    settings.ui.buttonBox.accepted.connect(interface)
    
      
    sys.exit(app.exec_())